﻿var timeout;
var mainRates;
var urlBYR = "http://www.nbrb.by/Services/XmlExRates.aspx";
var urlRUB = "http://www.cbr.ru/scripts/XML_daily.asp";
var urlEUR = "http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml";
var urlUAH = "http://bank-ua.com/export/currrate.xml";

var colors;
var rates;
var signs;
var banks = new Array("BYR", "RUB", "UAH", "EUR");
var icons;

function init() {
    initSettings();
    loadSettings();
    System.Gadget.Flyout.file = "Flyout.html";
    System.Gadget.Flyout.onShow = updateAllRates;
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = updateSettings;
    document.body.focus();
    doUpdate();
}
function initConst() {
    icons = new Object;
    icons["+"] = new Object; icons["+"]["up"] = "upp"; icons["+"]["down"] = "downn"; icons["+"]["stable"] = "stable";
    icons["-"] = new Object; icons["-"]["up"] = "upn"; icons["-"]["down"] = "downp"; icons["-"]["stable"] = "stable";
    signs = new Object;
    signs["BYR"] = "-"; signs["RUB"] = "-"; signs["UAH"] = "-"; signs["EUR"] = "+";
}

function initSettings() {
    initConst();
    colors = new Object;
    colors["BYR"] = "#FFFFFF";
    colors["RUB"] = "#FF9999";
    colors["UAH"] = "#FFFF99";
    colors["EUR"] = "#99FFFF";
    colors["USD"] = "#99FF99";

    rates = new Array(6);
    rates[0] = new Object; rates[0].cur1 = "RUB"; rates[0].cur2 = "USD";
    rates[1] = new Object; rates[1].cur1 = "UAH"; rates[1].cur2 = "USD";
    rates[2] = new Object; rates[2].cur1 = "BYR"; rates[2].cur2 = "USD";
    rates[3] = new Object; rates[3].cur1 = "RUB"; rates[3].cur2 = "$$$";
    rates[4] = new Object; rates[4].cur1 = "BYR"; rates[4].cur2 = "$$$";
    rates[5] = new Object; rates[5].cur1 = "EUR"; rates[5].cur2 = "USD";
}

function updateHighlight(styleSheet) {
    for (var i = styleSheet.rules.length - 1; i > -1; i--)
        if (styleSheet.rules[i].selectorText.substr(0, 4) == ".cur")
            styleSheet.removeRule(i);
    for (var cur in colors)
        styleSheet.addRule(".cur" + cur, "color: " + colors[cur]);
}

function loadSettings() {
    for (var i = 1; i <= 11; i++) {
        var cur = System.Gadget.Settings.readString("cur" + i);
        if (!cur) break;
        else if (i == 1) 
            colors = new Object;
        colors[cur] = System.Gadget.Settings.readString("color" + i);
    }
    updateHighlight(document.styleSheets[0]);
    for (i = 1; i <= 6; i++) {
        var cur1 = System.Gadget.Settings.readString("cur1" + i);
        var cur2 = System.Gadget.Settings.readString("cur2" + i);
        if (cur1) {
            rates[i - 1].cur1 = cur1;
            rates[i - 1].cur2 = cur2; 
        }
    }
    for (i = 1; i <= 4; i++) {
        var sign = System.Gadget.Settings.readString("sign" + i);
        if (sign) 
            signs[banks[i - 1]] = sign;
    }
}

function newXmlDoc() {
    var doc;
    if (window.ActiveXObject) {
        doc = new ActiveXObject("Microsoft.XMLDOM");
    } else if (document.implementation && document.implementation.createDocument) {
        doc = document.implementation.createDocument("", "", null);
    }
    return doc;
}

function compareItem(item1, item2) {
    if (item1.cur1 < item2.cur1) return -1;
    else if (item1.cur1 > item2.cur1) return 1;
    else if (item1.cur2 < item2.cur2) return -1;
    else if (item1.cur2 > item2.cur2) return 1;
    else return 0;
}

function getItem(data, cur1, cur2) {
    for (i = 0; i < data.length; i++)
        if ((data[i].cur1 == cur1) && (data[i].cur2 == cur2))
        return data[i];
}

function saveData(data) {
    var s = '<rates>';
    for (i = 0; i < data.length; i++) {
        s += '<rate cur1="' + data[i].cur1 + '" cur2="' + data[i].cur2 + '" value="' + data[i].value + '" date="' + data[i].date + '" quantity="' + data[i].quantity + '" changed="' + data[i].changed + '" />';
    }
    s += "</rates>";
    var doc = newXmlDoc();
    doc.loadXML(s);
    doc.save(System.Gadget.path + "\\rates.xml");
}

function loadData() {
    try {
        var doc = newXmlDoc();
        doc.load(System.Gadget.path + "\\rates.xml");
        var list = doc.getElementsByTagName("rate");
        var data = new Array(list.length);
        for (i = 0; i < list.length; i++) {
            var item = new Object;
            item.cur1 = list[i].getAttribute("cur1");
            item.cur2 = list[i].getAttribute("cur2");
            item.value = parseFloat(list[i].getAttribute("value"));
            item.date = list[i].getAttribute("date");
            item.changed = list[i].getAttribute("changed");
            item.quantity = parseFloat(list[i].getAttribute("quantity"));
            item.reverse = (item.cur1 == "EUR");
            data[i] = item;
        }
        return data.sort(compareItem);
    } catch (e) {
        return new Array();
    }
}

function compareData(data1, data2) {
    var j = 0;
    for (var i = 0; i < data1.length; i++) {
        while ((j < data2.length) && (compareItem(data2[j], data1[i]) < 0))
            j++;
        if (j >= data2.length) break;
        if (compareItem(data2[j], data1[i]) == 0) {
            if (data2[j].date == data1[i].date)
                data1[i].changed = data2[j].changed;
            else if (data1[i].value*data1[i].quantity < data2[j].value*data1[j].quantity)
                data1[i].changed = "down";
            else if (data1[i].value*data1[i].quantity > data2[j].value*data1[j].quantity)
                data1[i].changed = "up";
            else
                data1[i].changed = "stable";
        }
    }
}

function download(url) {
    var req = false;
    if (window.XMLHttpRequest && !(window.ActiveXObject))
        try {
        req = new XMLHttpRequest();
    } catch (e) {
        alert(e);
        req = false;
    }
    else if (window.ActiveXObject)
        try {
        req = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
        try {
            req = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (e) {
            alert(e);
            req = false;
        }
    }
    if (req) req.open("GET", url, false);
    req.send("");
    var objRecordset = new ActiveXObject("ADODB.Recordset");
    objRecordset.Fields.Append("ru", 200, 100000);
    objRecordset.Open;
    objRecordset.AddNew;
    objRecordset(0).AppendChunk(req.responseBody);
    var s = objRecordset.GetString(2);
    objRecordset.Close;
    var doc = newXmlDoc();
    doc.loadXML(s);
    return doc;
}

function loadBYR(data) {
    var doc = download(urlBYR);
    var date = doc.documentElement.getAttribute("Date");
    var list = doc.getElementsByTagName("Currency");
    var basket = 1.0;
    for (var i = 0; i < list.length; i++) {
        var item = new Object;
        item.cur1 = "BYR";
        item.date = date;
        item.changed = "stable";
        item.quantity = parseInt(list[i].getElementsByTagName("Scale")[0].text);
        item.cur2 = list[i].getElementsByTagName("CharCode")[0].text;
        item.value = parseFloat(list[i].getElementsByTagName("Rate")[0].text);
        item.reverse = false;
        data[data.length] = item;
        if ((item.cur2=="EUR") || (item.cur2=="USD") || (item.cur2=="RUB")) basket *= item.value;
    }
    var item = new Object;
    item.cur1 = "BYR";
    item.date = date;
    item.changed = "stable";
    item.quantity = 1;
    item.cur2 = "$$$";
    item.value = Math.round(Math.pow(basket, 1.0/3.0)*100.0)/100.0;
    item.reverse = false;
    data[data.length] = item;
}

function loadRUB(data) {
    var doc = download(urlRUB);
    var date = doc.documentElement.getAttribute("Date");
    var list = doc.getElementsByTagName("Valute");
    var basket = 0.0;
    for (var i = 0; i < list.length; i++) {
        var item = new Object;
        item.cur1 = "RUB";
        item.date = date;
        item.changed = "stable";
        item.quantity = parseInt(list[i].getElementsByTagName("Nominal")[0].text);
        item.cur2 = list[i].getElementsByTagName("CharCode")[0].text;
        item.value = list[i].getElementsByTagName("Value")[0].text;
        item.value = parseFloat(item.value.replace(/,/g, "."));
        item.reverse = false;
        data[data.length] = item;
        if (item.cur2=="EUR") basket += 45.0 * item.value;
        else if (item.cur2=="USD") basket += 55.0 * item.value;
    }
    var item = new Object;
    item.cur1 = "RUB";
    item.date = date;
    item.changed = "stable";
    item.quantity = 1;
    item.cur2 = "$$$";
    item.value = Math.round(basket)/100.0;
    item.reverse = false;
    data[data.length] = item;
    
}

function loadUAH(data) {
    var doc = download(urlUAH);
    var list = doc.getElementsByTagName("item");
    for (var i = 0; i < list.length; i++) {
        var item = new Object;
        item.cur1 = "UAH";
        item.date = list[i].getElementsByTagName("date")[0].text;
        item.changed = "stable";
        item.quantity = parseInt(list[i].getElementsByTagName("size")[0].text);
        item.cur2 = list[i].getElementsByTagName("char3")[0].text;
        item.value = parseFloat(list[i].getElementsByTagName("rate")[0].text);
        item.reverse = false;
        data[data.length] = item;
    }
}

function loadEUR(data) {
    var doc = download(urlEUR);
    var list = doc.getElementsByTagName("Cube");
    var date; 
    for (var i = 0; i < list.length; i++) {
        if (list[i].getAttribute("time") != null) {
            date = list[i].getAttribute("time");
            break;
        }
    }
    for (i = 0; i < list.length; i++) {
        if (list[i].getAttribute("currency") > "") {
            var item = new Object;
            item.cur1 = "EUR";
            item.date = date;
            item.changed = "stable";
            item.quantity = 1;
            item.cur2 = list[i].getAttribute("currency");
            item.value = parseFloat(list[i].getAttribute("rate"));
            item.reverse = true;
            data[data.length] = item;
        }
    }
}

function downloadData() {
    var data = new Array;
    loadBYR(data);
    loadRUB(data);
    loadEUR(data);
    loadUAH(data);
    for (var i=0; i<data.length; i++) {
        var item = data[i];
        while ((item.quantity>1) && (item.value>=10.0) && (item.quantity * item.value>100.00)) {
            item.value /= 10.0;
            item.quantity /= 10;
        }
        while (item.value<0.5) {
            item.value *= 10.0;
            item.quantity *= 10;
        }
    }
    return data.sort(compareItem);
}

function getLine(item) {
    with (item) {
        var icon = icons[signs[cur1]][changed];
        if (cur2=="$$$") {
            var v;
            if (cur1=="RUB") v = "RU&nbsp;¤&nbsp;2";
            else if (cur1=="BYR") v = "BY&nbsp;¤&nbsp;3";
            return '<tr><th class="basket cur' + cur1 + '">&nbsp;&nbsp;' + v + '</th><td class="cur' + cur1 + '"><image src="images/' + icon + '.png"/>&nbsp;' + value.toLocaleString() + '&nbsp;' + cur1 + '</td></tr>';
        }
        else if (reverse)
            return '<tr><th class="cur' + cur1 + '">&nbsp;&nbsp;' + quantity + '&nbsp;' + cur1 + '</th><td class="cur' + cur2 + '"><image src="images/' + icon + '.png"/>&nbsp;' + value.toLocaleString() + '&nbsp;' + cur2 + '</td></tr>';
        else
            return '<tr><th class="cur' + cur2 + '">&nbsp;&nbsp;' + quantity + '&nbsp;' + cur2 + '</th><td class="cur' + cur1 + '"><image src="images/' + icon + '.png"/>&nbsp;' + value.toLocaleString() + '&nbsp;' + cur1 + '</td></tr>';
    }
}

function getLine1(data, cur1, cur2) {
    var item = getItem(data, cur1, cur2);
    return getLine(item);
}

function updateMainRates(data) {
    var mainRates = '<table cellpadding="2" cellspacing="0" width="100%">';
    for (var i = 0; i < 6; i++) {
        mainRates += getLine1(data, rates[i].cur1, rates[i].cur2);
    }
    mainRates += '<tr><td colspan="2" align="right"><a href="javascript:showAllRates();" onmouseenter="larr.src=' + "'images/leftw.png';" + '" onmouseleave="larr.src=' + "'images/left.png';" + '">';
    mainRates += '<img border="0" id="larr" src="images/left.png" width="9px" height="9px"> '+sAllRates+'&nbsp;&nbsp;</a></td></tr></table>';
    document.getElementById("mainRates").innerHTML = mainRates;
}

function doUpdate() {
    timeout = setTimeout("doUpdate();", 3600000); // 1h
    var data1 = downloadData();
    var data2 = loadData();
    compareData(data1, data2);
    updateMainRates(data1);
    saveData(data1);
}

function showAllRates() {
    System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}

function updateAllRates() {
    initConst();
    var currency = System.Gadget.Settings.readString("currency");
    if (!currency) currency = "RUB";
    var data = loadData();
    var allRates = '<table id="tblRates" cellpadding="2" cellspacing="0">';
    allRates += '<tr><td colspan="2" align="right">'+sBank+' <select id="bank" onchange="System.Gadget.Settings.writeString('+"'currency'"+', this.value); updateAllRates();">';
    for (var i = 0; i < 4; i++) {
        allRates += '<option value="' + banks[i] + '"';
        if (currency == banks[i]) allRates += ' selected="selected"'; 
        allRates += '>'+bankNames[i]+'</option>';
    }
    allRates += '</select></td></tr>';
    for (i = 0; i < data.length; i++) {
        if (data[i].cur1 == currency)
            allRates += getLine(data[i]);
    }
    allRates += '<tr><td colspan="2" align="right"><a href="javascript:showAllRates();" onmouseenter="rarr.src=' + "'images/rightw.png';" + '" onmouseleave="rarr.src=' + "'images/right.png';" + '">';
    allRates += sClose+'&nbsp;<img border="0" id="rarr" src="images/right.png" width="9px" height="9px"></a></td></tr></table>';
    System.Gadget.Flyout.document.getElementById("allRates").innerHTML = allRates;
    System.Gadget.Flyout.document.body.style.width = System.Gadget.Flyout.document.getElementById("tblRates").clientWidth + "px";
    System.Gadget.Flyout.document.body.style.height = System.Gadget.Flyout.document.getElementById("tblRates").clientHeight + "px";
}

function updateSettings() {
    loadSettings();
    var data = loadData();
    updateMainRates(data);
}